## visad
Interface Display

All Superinterfaces:
  Action, EventListener, ThingChangedListener

All Known Subinterfaces:
  LocalDisplay, RemoteDisplay

All Known Implementing Classes:
  DisplayImpl, RemoteDisplayImpl

public interface Display
extends Action

Display is the VisAD interface for displays. It is runnable.

The display architecture is based on three goals:

1. Display data according to a set of mappings from RealType's (e.g., Latitude, Time, Pressure) to DisplayRealTypes (e.g., XAxis, RGB, Animation).

2. Allow user extensions, to define new DisplayRealTypes, new DisplayTupleTypes (and hence new display CoordinateSystems), and new rendering algorithms.

3. Support direct manipulation, where users modify Data values by re-drawing their depictions.

Field Summary
`static DisplayRealType` `AdjustProjectionSeam` Adjust along projection seams - ConstantMap only
`static DisplayRealType` `Alpha` display alpha (transparency)
`static DisplayRealType` `Animation` display animation
`static DisplayRealType` `Blue` display color blue coordinate (in RGB)
`static DisplayRealType` `CMY` display color CMY lookup table index
`static DisplayRealType` `ColorMode` color mode - ConstantMap only, values must be > 0
`static DisplayRealType[]` `components3c` array of 3D Cartesian spatial coordinates
`static DisplayRealType[]` `components3s` array of 3D spherical spatial coordinates
`static DisplayRealType[]` `componentscmy` array of 3D CMY coordinates
`static DisplayRealType[]` `componentscyl` array of 3D cylindrical Coordinates
`static DisplayRealType[]` `componentsflow1` array of 3D Cartesian flow set 1 coordinates
`static DisplayRealType[]` `componentsflow1s` array of 3D spherical flow set 1 coordinates
`static DisplayRealType[]` `componentsflow2` array of 3D Cartesian flow set 2 coordinates
`static DisplayRealType[]` `componentsflow2s` array of 3D spherical flow set 2 coordinates
`static DisplayRealType[]` `componentshsv` array of 3D HSV coordinates
`static DisplayRealType[]` `componentsrgb` array of 3D RGB coordinates
`static DisplayRealType[]` `componentsso` array of 3D Cartesian spatial offset coordinates
`static DisplayRealType` `CurvedSize` curved size - ConstantMap only, values must be > 0
`static DisplayRealType` `Cyan` display color cyan coordinate (in CMY)
`static DisplayRealType` `CylAzimuth` display spatial cylindrical azimuth coordinate
`static DisplayRealType` `CylRadius` display spatial cylindrical radius coordinate
`static DisplayRealType` `CylZAxis` display spatial cylindrical Z axis coordinate
`static CoordinateSystem` `DisplayCMYCoordSys` CoordinateSystem for DisplayCMYTuple, with reference DisplayRGBTuple
`static DisplayTupleType` `DisplayCMYTuple` system intrinsic DisplayTupleType for CMY color coordinates
`static CoordinateSystem` `DisplayCylindricalCoordSys` CoordinateSystem for DisplaySpatialCylindricalTuple, with reference DisplaySpatialCartesianTuple
`static CoordinateSystem` `DisplayFlow1SphericalCoordSys` CoordinateSystem for DisplayFlow1SphericalTuple, with reference DisplayFlow1Tuple
`static DisplayTupleType` `DisplayFlow1SphericalTuple` system intrinsic DisplayTupleType for 3D spherical flow set 1 coordinates
`static DisplayTupleType` `DisplayFlow1Tuple` system intrinsic DisplayTupleType for 3D Cartesian flow set 1 coordinates
`static CoordinateSystem` `DisplayFlow2SphericalCoordSys` CoordinateSystem for DisplayFlow2SphericalTuple, with reference DisplayFlow2Tuple
`static DisplayTupleType` `DisplayFlow2SphericalTuple` system intrinsic DisplayTupleType for 3D spherical flow set 2 coordinates
`static DisplayTupleType` `DisplayFlow2Tuple` system intrinsic DisplayTupleType for 3D Cartesian flow set 2 coordinates
`static CoordinateSystem` `DisplayHSVCoordSys` CoordinateSystem for DisplayHSVTuple, with reference DisplayRGBTuple
`static DisplayTupleType` `DisplayHSVTuple` system intrinsic DisplayTupleType for HSV color coordinates
`static DisplayRealType[]` `DisplayRealArray` array of system intrinsic DisplayRealTypes
`static DisplayTupleType` `DisplayRGBTuple` system intrinsic DisplayTupleType for RGB color coordinates
`static DisplayTupleType` `DisplaySpatialCartesianTuple` system intrinsic DisplayTupleType for 3D Cartesian spatial coordinates
`static DisplayTupleType` `DisplaySpatialCylindricalTuple` system intrinsic DisplayTupleType for 3D cylindrical spatial coordinates
`static DisplayTupleType` `DisplaySpatialOffsetTuple` system intrinsic DisplayTupleType for 3D Cartesian spatial offset coordinates
`static DisplayTupleType` `DisplaySpatialSphericalTuple` system intrinsic DisplayTupleType for 3D spherical spatial coordinates
`static CoordinateSystem` `DisplaySphericalCoordSys` CoordinateSystem for DisplaySpatialSphericalTuple, with reference DisplaySpatialCartesianTuple
`static DisplayRealType` `Flow1Azimuth` display flow set 1 spherical azimuth coordinate
`static DisplayRealType` `Flow1Elevation` display flow set 1 spherical elevation coordinate
`static DisplayRealType` `Flow1Radial` display flow set 1 spherical radial coordinate
`static DisplayRealType` `Flow1X` display flow set 1 Cartesian X axis coordinate
`static DisplayRealType` `Flow1Y` display flow set 1 Cartesian Y axis coordinate
`static DisplayRealType` `Flow1Z` display flow set 1 Cartesian Z axis coordinate
`static DisplayRealType` `Flow2Azimuth` display flow set 2 spherical azimuth coordinate
`static DisplayRealType` `Flow2Elevation` display flow set 2 spherical elevation coordinate
`static DisplayRealType` `Flow2Radial` display flow set 2 spherical radial coordinate
`static DisplayRealType` `Flow2X` display flow set 2 Cartesian X axis coordinate
`static DisplayRealType` `Flow2Y` display flow set 2 Cartesian Y axis coordinate
`static DisplayRealType` `Flow2Z` display flow set 2 Cartesian Z axis coordinate
`static DisplayRealType` `Green` display color green coordinate (in RGB)
`static DisplayRealType` `HSV` display color HSV lookup table index
`static DisplayRealType` `Hue` display color hue coordinate (in HSV)
`static DisplayRealType` `IsoContour` display iso-contour
`static DisplayRealType` `Latitude` display spatial spherical Latitude coordinate
`static DisplayRealType` `LineStyle` line style - ConstantMap only
`static DisplayRealType` `LineWidth` line width - ConstantMap only
`static DisplayRealType` `List` list display scalar (not used)
`static DisplayRealType` `Longitude` display spatial spherical Longitude coordinate
`static DisplayRealType` `Magenta` display color magenta coordinate (in CMY)
`static DisplayRealType` `MissingTransparent` missing transparent - ConstantMap only
`static DisplayRealType` `PointSize` point size - ConstantMap only
`static DisplayRealType` `PolygonMode` polygon mode - ConstantMap only
`static DisplayRealType` `PolygonOffset` Polygon offset - ConstantMap only
`static DisplayRealType` `PolygonOffsetFactor` Polygon offset factor - ConstantMap only
`static DisplayRealType` `Radius` display spatial spherical Radius coordinate
`static DisplayRealType` `Red` display color red coordinate (in RGB)
`static DisplayRealType` `RGB` display color RGB lookup table index
`static DisplayRealType` `RGBA` display color RGBA lookup table index
`static DisplayRealType` `Saturation` display color saturation coordinate (in HSV)
`static DisplayRealType` `SelectRange` display scalar for selecting by a range of values
`static DisplayRealType` `SelectValue` display scalar for selecting by a single value
`static DisplayRealType` `Shape` index into a set of display shapes
`static DisplayRealType` `ShapeScale` scale for display shapes
`static DisplayRealType` `Text` display scalar for text
`static DisplayRealType` `Texture3DMode` texture 3D mode - ConstantMap only, values must be > 0
`static DisplayRealType` `TextureEnable` texture enable - ConstantMap only
`static DisplayRealType` `Value` display color value coordinate (in HSV)
`static DisplayRealType` `XAxis` display spatial Cartesian X axis coordinate
`static DisplayRealType` `XAxisOffset` display spatial offset Cartesian X axis coordinate
`static DisplayRealType` `YAxis` display spatial Cartesian Y axis coordinate
`static DisplayRealType` `YAxisOffset` display spatial offset Cartesian Y axis coordinate
`static DisplayRealType` `Yellow` display color yellow coordinate (in CMY)
`static DisplayRealType` `ZAxis` display spatial Cartesian Z axis coordinate
`static DisplayRealType` `ZAxisOffset` display spatial offset Cartesian Z axis coordinate

Method Summary
`void` `addMap(ScalarMap map)` link a ScalarMap (may be a ConstantMap) to this Display
`void` `addReference(DataReference ref, ConstantMap[] constant_maps)` create link to DataReference, with ConstantMaps; invokes ref.addThingChangedListener(ThingChangedListener l, long id)
`void` `addReferences(DataRenderer renderer, DataReference ref, ConstantMap[] constant_maps)` create link to DataReference, with ConstantMaps and DataRenderer; invokes ref.addThingChangedListener(ThingChangedListener l, long id)
`void` `addSlave(RemoteSlaveDisplay display)` link a slave display to this display
`void` `clearMaps()` remove all ScalarMaps (and ConstantMaps) from this Display
`void` `destroy()` destroy this display: break all links, stop Threads and clear references for garbage collection
`Vector` `getConstantMapVector()`
`boolean` `hasSlaves()`
`void` `removeAllSlaves()` remove all slave displays from this display
`void` `removeMap(ScalarMap map)` remove a ScalarMap (may be a ConstantMap) from this Display
`void` `removeSlave(RemoteSlaveDisplay display)` remove a slave display from this display
`void` `sendMessage(MessageEvent msg)` Send a message to all MessageListeners.

Methods inherited from interface visad.Action
`addReference, getName, removeAllReferences, removeReference`

Methods inherited from interface visad.ThingChangedListener
`thingChanged`

Field Detail

### XAxis

    public static final DisplayRealType XAxis

  display spatial Cartesian X axis coordinate

### YAxis

    public static final DisplayRealType YAxis

  display spatial Cartesian Y axis coordinate

### ZAxis

    public static final DisplayRealType ZAxis

  display spatial Cartesian Z axis coordinate

### Latitude

    public static final DisplayRealType Latitude

  display spatial spherical Latitude coordinate

### Longitude

    public static final DisplayRealType Longitude

  display spatial spherical Longitude coordinate

### Radius

    public static final DisplayRealType Radius

  display spatial spherical Radius coordinate

### CylRadius

    public static final DisplayRealType CylRadius

  display spatial cylindrical radius coordinate

### CylAzimuth

    public static final DisplayRealType CylAzimuth

  display spatial cylindrical azimuth coordinate

### CylZAxis

    public static final DisplayRealType CylZAxis

  display spatial cylindrical Z axis coordinate

### XAxisOffset

    public static final DisplayRealType XAxisOffset

  display spatial offset Cartesian X axis coordinate

### YAxisOffset

    public static final DisplayRealType YAxisOffset

  display spatial offset Cartesian Y axis coordinate

### ZAxisOffset

    public static final DisplayRealType ZAxisOffset

  display spatial offset Cartesian Z axis coordinate

### List

    public static final DisplayRealType List

  list display scalar (not used)

### Red

    public static final DisplayRealType Red

  display color red coordinate (in RGB)

### Green

    public static final DisplayRealType Green

  display color green coordinate (in RGB)

### Blue

    public static final DisplayRealType Blue

  display color blue coordinate (in RGB)

### RGB

    public static final DisplayRealType RGB

  display color RGB lookup table index

### RGBA

    public static final DisplayRealType RGBA

  display color RGBA lookup table index

### Hue

    public static final DisplayRealType Hue

  display color hue coordinate (in HSV)

### Saturation

    public static final DisplayRealType Saturation

  display color saturation coordinate (in HSV)

### Value

    public static final DisplayRealType Value

  display color value coordinate (in HSV)

### HSV

    public static final DisplayRealType HSV

  display color HSV lookup table index

### Cyan

    public static final DisplayRealType Cyan

  display color cyan coordinate (in CMY)

### Magenta

    public static final DisplayRealType Magenta

  display color magenta coordinate (in CMY)

### Yellow

    public static final DisplayRealType Yellow

  display color yellow coordinate (in CMY)

### CMY

    public static final DisplayRealType CMY

  display color CMY lookup table index

### Alpha

    public static final DisplayRealType Alpha

  display alpha (transparency)

### Animation

    public static final DisplayRealType Animation

  display animation

### SelectValue

    public static final DisplayRealType SelectValue

  display scalar for selecting by a single value

### SelectRange

    public static final DisplayRealType SelectRange

  display scalar for selecting by a range of values

### IsoContour

    public static final DisplayRealType IsoContour

  display iso-contour

### Flow1X

    public static final DisplayRealType Flow1X

  display flow set 1 Cartesian X axis coordinate

### Flow1Y

    public static final DisplayRealType Flow1Y

  display flow set 1 Cartesian Y axis coordinate

### Flow1Z

    public static final DisplayRealType Flow1Z

  display flow set 1 Cartesian Z axis coordinate

### Flow1Elevation

    public static final DisplayRealType Flow1Elevation

  display flow set 1 spherical elevation coordinate

### Flow1Azimuth

    public static final DisplayRealType Flow1Azimuth

  display flow set 1 spherical azimuth coordinate

### Flow1Radial

    public static final DisplayRealType Flow1Radial

  display flow set 1 spherical radial coordinate

### Flow2X

    public static final DisplayRealType Flow2X

  display flow set 2 Cartesian X axis coordinate

### Flow2Y

    public static final DisplayRealType Flow2Y

  display flow set 2 Cartesian Y axis coordinate

### Flow2Z

    public static final DisplayRealType Flow2Z

  display flow set 2 Cartesian Z axis coordinate

### Flow2Elevation

    public static final DisplayRealType Flow2Elevation

  display flow set 2 spherical elevation coordinate

### Flow2Azimuth

    public static final DisplayRealType Flow2Azimuth

  display flow set 2 spherical azimuth coordinate

### Flow2Radial

    public static final DisplayRealType Flow2Radial

  display flow set 2 spherical radial coordinate

### Shape

    public static final DisplayRealType Shape

  index into a set of display shapes

### ShapeScale

    public static final DisplayRealType ShapeScale

  scale for display shapes

### Text

    public static final DisplayRealType Text

  display scalar for text

### LineWidth

    public static final DisplayRealType LineWidth

  line width - ConstantMap only

### PointSize

    public static final DisplayRealType PointSize

  point size - ConstantMap only

### LineStyle

    public static final DisplayRealType LineStyle

  line style - ConstantMap only

### TextureEnable

    public static final DisplayRealType TextureEnable

  texture enable - ConstantMap only

### MissingTransparent

    public static final DisplayRealType MissingTransparent

  missing transparent - ConstantMap only

### PolygonMode

    public static final DisplayRealType PolygonMode

  polygon mode - ConstantMap only

### CurvedSize

    public static final DisplayRealType CurvedSize

  curved size - ConstantMap only, values must be > 0

### ColorMode

    public static final DisplayRealType ColorMode

  color mode - ConstantMap only, values must be > 0

### PolygonOffset

    public static final DisplayRealType PolygonOffset

  Polygon offset - ConstantMap only

### PolygonOffsetFactor

    public static final DisplayRealType PolygonOffsetFactor

  Polygon offset factor - ConstantMap only

### AdjustProjectionSeam

    public static final DisplayRealType AdjustProjectionSeam

  Adjust along projection seams - ConstantMap only

### Texture3DMode

    public static final DisplayRealType Texture3DMode

  texture 3D mode - ConstantMap only, values must be > 0

### DisplayRealArray

    public static final DisplayRealType[] DisplayRealArray

  array of system intrinsic DisplayRealTypes

### components3c

    public static final DisplayRealType[] components3c

  array of 3D Cartesian spatial coordinates

### DisplaySpatialCartesianTuple

    public static final DisplayTupleType DisplaySpatialCartesianTuple

  system intrinsic DisplayTupleType for 3D Cartesian spatial coordinates

### DisplaySphericalCoordSys

    public static final CoordinateSystem DisplaySphericalCoordSys

  CoordinateSystem for DisplaySpatialSphericalTuple, with reference DisplaySpatialCartesianTuple

### components3s

    public static final DisplayRealType[] components3s

  array of 3D spherical spatial coordinates

### DisplaySpatialSphericalTuple

    public static final DisplayTupleType DisplaySpatialSphericalTuple

  system intrinsic DisplayTupleType for 3D spherical spatial coordinates

### DisplayCylindricalCoordSys

    public static final CoordinateSystem DisplayCylindricalCoordSys

  CoordinateSystem for DisplaySpatialCylindricalTuple, with reference DisplaySpatialCartesianTuple

### componentscyl

    public static final DisplayRealType[] componentscyl

  array of 3D cylindrical Coordinates

### DisplaySpatialCylindricalTuple

    public static final DisplayTupleType DisplaySpatialCylindricalTuple

  system intrinsic DisplayTupleType for 3D cylindrical spatial coordinates

### componentsrgb

    public static final DisplayRealType[] componentsrgb

  array of 3D RGB coordinates

### DisplayRGBTuple

    public static final DisplayTupleType DisplayRGBTuple

  system intrinsic DisplayTupleType for RGB color coordinates

### DisplayHSVCoordSys

    public static final CoordinateSystem DisplayHSVCoordSys

  CoordinateSystem for DisplayHSVTuple, with reference DisplayRGBTuple

### componentshsv

    public static final DisplayRealType[] componentshsv

  array of 3D HSV coordinates

### DisplayHSVTuple

    public static final DisplayTupleType DisplayHSVTuple

  system intrinsic DisplayTupleType for HSV color coordinates

### DisplayCMYCoordSys

    public static final CoordinateSystem DisplayCMYCoordSys

  CoordinateSystem for DisplayCMYTuple, with reference DisplayRGBTuple

### componentscmy

    public static final DisplayRealType[] componentscmy

  array of 3D CMY coordinates

### DisplayCMYTuple

    public static final DisplayTupleType DisplayCMYTuple

  system intrinsic DisplayTupleType for CMY color coordinates

### componentsflow1

    public static final DisplayRealType[] componentsflow1

  array of 3D Cartesian flow set 1 coordinates

### DisplayFlow1Tuple

    public static final DisplayTupleType DisplayFlow1Tuple

  system intrinsic DisplayTupleType for 3D Cartesian flow set 1 coordinates

### componentsflow2

    public static final DisplayRealType[] componentsflow2

  array of 3D Cartesian flow set 2 coordinates

### DisplayFlow2Tuple

    public static final DisplayTupleType DisplayFlow2Tuple

  system intrinsic DisplayTupleType for 3D Cartesian flow set 2 coordinates

### DisplayFlow1SphericalCoordSys

    public static final CoordinateSystem DisplayFlow1SphericalCoordSys

  CoordinateSystem for DisplayFlow1SphericalTuple, with reference DisplayFlow1Tuple

### componentsflow1s

    public static final DisplayRealType[] componentsflow1s

  array of 3D spherical flow set 1 coordinates

### DisplayFlow1SphericalTuple

    public static final DisplayTupleType DisplayFlow1SphericalTuple

  system intrinsic DisplayTupleType for 3D spherical flow set 1 coordinates

### DisplayFlow2SphericalCoordSys

    public static final CoordinateSystem DisplayFlow2SphericalCoordSys

  CoordinateSystem for DisplayFlow2SphericalTuple, with reference DisplayFlow2Tuple

### componentsflow2s

    public static final DisplayRealType[] componentsflow2s

  array of 3D spherical flow set 2 coordinates

### DisplayFlow2SphericalTuple

    public static final DisplayTupleType DisplayFlow2SphericalTuple

  system intrinsic DisplayTupleType for 3D spherical flow set 2 coordinates

### componentsso

    public static final DisplayRealType[] componentsso

  array of 3D Cartesian spatial offset coordinates

### DisplaySpatialOffsetTuple

    public static final DisplayTupleType DisplaySpatialOffsetTuple

  system intrinsic DisplayTupleType for 3D Cartesian spatial offset coordinates

Method Detail

### addReference

    public void addReference(DataReference ref,
                             ConstantMap[] constant_maps)
                      throws VisADException,
                             RemoteException

  create link to DataReference, with ConstantMaps; invokes ref.addThingChangedListener(ThingChangedListener l, long id)

  Parameters:
    `ref` - DataReference to link to
    `constant_maps` - array of ConstantMaps applied to linked Data
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### addReferences

    public void addReferences(DataRenderer renderer,
                              DataReference ref,
                              ConstantMap[] constant_maps)
                       throws VisADException,
                              RemoteException

  create link to DataReference, with ConstantMaps and DataRenderer; invokes ref.addThingChangedListener(ThingChangedListener l, long id)

  Parameters:
    `renderer` - DataRenderer used to depict linked Data
    `ref` - DataReference to link to
    `constant_maps` - array of ConstantMaps applied to this Data
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### addMap

    public void addMap(ScalarMap map)
                throws VisADException,
                       RemoteException

  link a ScalarMap (may be a ConstantMap) to this Display

  Parameters:
    `map` - ScalarMap to link
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### removeMap

    public void removeMap(ScalarMap map)
                   throws VisADException,
                          RemoteException

  remove a ScalarMap (may be a ConstantMap) from this Display

  Parameters:
    `map` - ScalarMap to remove
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### clearMaps

    public void clearMaps()
                   throws VisADException,
                          RemoteException

  remove all ScalarMaps (and ConstantMaps) from this Display

  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### destroy

    public void destroy()
                 throws VisADException,
                        RemoteException

  destroy this display: break all links, stop Threads and clear references for garbage collection

  Throws:
    `VisADException`
    `RemoteException`

### getConstantMapVector

    public Vector getConstantMapVector()
                                throws VisADException,
                                       RemoteException

  Returns:
    Vector of linked ConstantMaps
  Throws:
    `VisADException`
    `RemoteException`

### sendMessage

    public void sendMessage(MessageEvent msg)
                     throws RemoteException

  Send a message to all MessageListeners.

  Parameters:
    `msg` - Message being sent.
  Throws:
    `RemoteException` - an RMI error occurred

### addSlave

    public void addSlave(RemoteSlaveDisplay display)
                  throws VisADException,
                         RemoteException

  link a slave display to this display

  Parameters:
    `display` - RemoteSlaveDisplay to link
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### removeSlave

    public void removeSlave(RemoteSlaveDisplay display)
                     throws VisADException,
                            RemoteException

  remove a slave display from this display

  Parameters:
    `display` - RemoteSlaveDisplay to remove
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### removeAllSlaves

    public void removeAllSlaves()
                         throws VisADException,
                                RemoteException

  remove all slave displays from this display

  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### hasSlaves

    public boolean hasSlaves()
                      throws VisADException,
                             RemoteException

  Returns:
    true if this display has any slave displays
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred